#
# $Id$
#

# Copyright INRA

# Mathieu.Gautier@supagro.inra.fr
# Astrid.Cruaud@supagro.inra.fr
# Jerome.Gouzy@toulouse.inra.fr

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
 

sub SliceSystem
{
my($i,$ra_tasks,$ra_inputs,$rsh_)=@_;

	#system("$$ra_tasks[$i]");
    #&System($$ra_tasks[$i],&FALSE,undef);
    &System($$ra_tasks[$i],$main::DEBUG,undef);
}

sub GetListOfFiles
{
my($datadir,$listofext)=@_;

        my $cde = "";
        foreach my $ext (split(' ',$listofext))
        {
                $cde .= " $datadir/$ext ";
        }
        $cde = "ls $cde 2>/dev/null";

        my @a_files = `$cde`;
        if ( scalar(@a_files) < 1 )
        {
                Carp::croak("No data files >$listofext< found in $datadir");
        }
        chomp(@a_files);
        return (@a_files);
}

=head2 procedure PrintJobStatus

 Title        : PrintJobStatus
 Usage        : &PrintJobStatus($msg,$status,$verbose)
 Prerequisite : none
 Fonction     : Print a one-line formatted message
 Returns      : none
 Args         : $msg: the message to be displayed
                $status: a string defining the status (started, done, ...)
                $verbose: a flag to control the message printing
 Globals      : none

=cut

sub PrintJobStatus
{
my($msg,$status,$verbose)=@_;

        return if ( !defined($verbose) );
        my $lmsg=length($msg);
        my $sep = '.' x (120 - $lmsg);
        print "$msg.$sep.$status\n";
        return;
}

=head2 procedure ErrMsg

=cut

sub ErrMsg
{
my($str)=@_;

        my $s = '=' x length($0);
        Carp::croak("$s\n$0\n$s\n$str\n");
}

=head2 fonction System

=cut

sub System
{
my($cde,$debug,$stderr) = @_;

	if ( !defined($stderr) && ($cde !~ /2>/ ))
	{
		$cde = " ( $cde ) 2> /dev/null ";
	}
	if ( $debug )
	{
		print "$cde\n";
	}
	return system($cde);
}

=head2 NoSpace

=cut

sub NoSpace
{
my($r_str)=@_;

	$$r_str =~ s/^\s+//;
	$$r_str =~ s/\s+$//;
}

sub AssertInteger
{
my($val)=@_;

	if ( $val !~ /^\d+$/ )
	{
		Carp::croak("Integer value expected >$val<\n");
	}
}

1;
